<h1 align="center">&lt;code-syntax /&gt;</h1>

<p align="center">
code syntax highlight custom element
</p>

<p align="center">
   <a href="#install">        🔧 <strong>Install</strong></a>
 · <a href="#example">        🧩 <strong>Example</strong></a>
 · <a href="#api">            📜 <strong>API docs</strong></a>
 · <a href="https://github.com/stagas/code-syntax/releases"> 🔥 <strong>Releases</strong></a>
 · <a href="#contribute">     💪🏼 <strong>Contribute</strong></a>
 · <a href="https://github.com/stagas/code-syntax/issues">   🖐️ <strong>Help</strong></a>
</p>

***

## Install

```sh
$ npm i code-syntax
```

## API

<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

#### Table of Contents

*   [CodeSyntaxElement](#codesyntaxelement)
*   [compile](#compile)
    *   [Parameters](#parameters)
*   [syntax](#syntax)
    *   [Parameters](#parameters-1)

### CodeSyntaxElement

[src/element.ts:44-116](https://github.com/stagas/code-syntax/blob/f7d7a13ded13fbcfecd54aa9aa0d02e98c18ef4e/src/element.ts#L44-L116 "Source code on GitHub")

**Extends HTMLElement**

CodeSyntax custom element

```js
import { CodeSyntaxElement } from 'code-syntax'
customElements.define('code-syntax', CodeSyntaxElement)
```

### compile

[src/syntax.ts:22-45](https://github.com/stagas/code-syntax/blob/f7d7a13ded13fbcfecd54aa9aa0d02e98c18ef4e/src/syntax.ts#L22-L45 "Source code on GitHub")

Compiles a syntax definition.

```js
const r = await compile({
  foo: /[a-z]/,
  bar: /[0-9]/,
})
```

#### Parameters

*   `def` **(SyntaxDefinition | [Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)<{default: SyntaxDefinition}>)** The syntax definition to compile. Can be a promise returned by `import()`.
*   `keys` **[Set](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Set)<[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** &#x20;(optional, default `new Set()`)

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)\<RegExpMapped>**&#x20;

### syntax

[src/syntax.ts:66-77](https://github.com/stagas/code-syntax/blob/f7d7a13ded13fbcfecd54aa9aa0d02e98c18ef4e/src/syntax.ts#L66-L77 "Source code on GitHub")

Syntax highlights a string as html with the given syntax.

```js
const regexp = await compile({
  foo: /[a-z]+/,
  bar: [
    /[0-9]+/,
    {
      bar: /[0-5]+/,
    },
  ],
})
const html = syntax(regexp, 'hello 123 789 world')
```

#### Parameters

*   `regexp` **RegExpMapped** The syntax definition returned by `compile()`
*   `s` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The string to highlight.

Returns **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)**&#x20;

## Contribute

[Fork](https://github.com/stagas/code-syntax/fork) or
[edit](https://github.dev/stagas/code-syntax) and submit a PR.

All contributions are welcome!

## License

MIT © 2021
[stagas](https://github.com/stagas)
